!!ARBfp1.0
#Fog coloring taken from ARB_fp doc.

#PARAM t0t1 = program.local[0];
#PARAM mvpi[]={state.matrix.mvp.inverse};

PARAM p = {0.1, 0, 0, 0}; #density/ln(2)
PARAM fogColor = state.fog.color;
TEMP fogFactor;

PARAM ones = {1.0,1.0,1.0,1.0};
PARAM hardness = {20,20,20,20};
PARAM half = {0.5,0.5,0.5,0.5};
TEMP t0,t1,t2,t3,t4,t5,t6,t7,temp,temp2,temp3,temp4;
TEMP spec,view,hv, finalColor;

ATTRIB fogCoord = fragment.fogcoord;
ATTRIB tc0 = fragment.texcoord[0];
ATTRIB fpos = fragment.texcoord[1];#eye position 
ATTRIB norm = fragment.texcoord[2];#norm position 
ATTRIB ldir = fragment.texcoord[3];#norm position 

TEX t0,tc0,texture[0],2D;
TEX t1,tc0,texture[1],2D;
TEX t2,tc0,texture[2],2D;


MUL view,fpos,1;
DP3 temp,view,view;
RSQ temp,temp.x;
MUL view,view,temp;

MOV hv,ldir;
DP3 temp,hv,hv;
RSQ temp,temp.x;
MUL hv,hv,temp;

ADD hv,hv,view;
DP3 temp,hv,hv;
RSQ temp,temp.x;
MUL hv,hv,temp;

DP3 spec,norm,hv;

MAX spec,spec,{0,0,0,0};
MOV temp.xyzw,t0.x;
LRP temp,temp,t1,{1,1,1,1} ;
MOV temp.w,1;

POW spec,spec.x,hardness.x;
MUL spec,spec,0.6;
ADD spec,spec,1.0;
MUL t2,t2,spec;

#ADD t2,t2,spec;
#MIN t2,t2,{1,1,1,1};
#MAX t2,t2,{0,0,0,0};

LRP temp,t0.yyyy,t2,temp;
MOV temp.w,1;
#LRP temp,half,temp2,temp;

MUL finalColor, temp, fragment.color;

# Fog
MUL fogFactor.x, p.x, fragment.position.z;#fogCoord.x;
EX2_SAT fogFactor.x, -fogFactor.x;
LRP result.color, fogFactor.x, finalColor, fogColor;
#End fog

# Instead of
#MUL result.color,temp,fragment.color;

#MOV result.color,fragment.color.secondary;
#MOV result.color,view;
#MOV spec.w,1;
#MOV result.color,spec;

END
